% Processo tempo continuo
G = tf([10],[.01 .1 1]);

% Periodo di campionamento
T = .01;

% Sistema a dati campionati
G_z = c2d(G,T,'zoh');
[num,den] = tfdata(G_z);

% Specifica dinamica ta1% <= 1 s
tau_max = 1/4.6;

% Minimo autovalore a ciclo chiuso
lambda_max = exp(-T/tau_max);

% Polinomio caratteristico a ciclo chiuso - vettore dei termini noti
c_z = conv([1 -.9],conv([1 -.4],[1 -.5])); 

% Matrice dei coefficienti 
Coeff = [
    1 0 0 0
    den{1}(2) 1 num{1}(2) 0
    den{1}(3) den{1}(2) num{1}(3) num{1}(2)
    0 den{1}(3) 0 num{1}(3)
];

% Coefficienti del controllore
x = inv(Coeff)*c_z';

R_z = tf([x(3:4)]',[x(1:2)]',T);

T_z = feedback(G_z*R_z,1);

figure

step(T_z,1.3)

pause

% Astatismo per riferimento a gradino
G_aug = G_z*tf([1 0],[1 -1],T);
[num,den] = tfdata(G_aug);

% Polinomio caratteristico a ciclo chiuso - vettore dei termini noti
c_z2 = conv(conv(c_z,[1 -.45]),[1 -.55]);

% Matrice dei coefficienti
Coeff2 = [
    1 0 0 0 0 0
    den{1}(2) 1 0 num{1}(2) 0 0
    den{1}(3) den{1}(2) 1 num{1}(3) num{1}(2) 0
    den{1}(4) den{1}(3) den{1}(2) num{1}(4) num{1}(3) num{1}(2)
    0 den{1}(4) den{1}(3) 0 num{1}(4) num{1}(3)
    0 0 den{1}(4) 0 0 num{1}(4)
];

x = inv(Coeff2)*c_z2';

R_z2 = tf([x(4:6)]',[x(1:3)]',T)*tf([1 0],[1 -1],T);

T_z2 = feedback(G_z*R_z2,1);

figure 

step(T_z2,1.3)

pause

% Schema a due gradi di libert
[numG,denG] = tfdata(G_z);
[numT,denT] = tfdata(T_z2);
H_z = conv([1 -.3],[1 -.3]);
H_z = sum(denT{1})/sum(numG{1})*H_z/sum(H_z);

figure 

sys_cl = tf(conv(H_z,numG{1}),c_z2,T);
step(sys_cl,1.5)